--1. Database action audits:
--create audit
use master
CREATE SERVER AUDIT audit1 TO FILE(FILEPATH='c:\temp\');
go

create database audit_test
go

--setup
use audit_test
go

create user test without login
go

create schema schema1
go
create table schema1.t1 (c int)
go
insert schema1.t1(c) values (1234)
go

grant select on schema::schema1 to test
go

--create audit specification
CREATE DATABASE AUDIT SPECIFICATION TestAuditSpec FOR SERVER AUDIT audit1
add(select on schema1.t1 by test)
go

--Verify Audit is off (0 = Disabled)
select is_state_enabled from sys.server_file_audits
select is_state_enabled from sys.database_audit_specifications
go

--turn on audit
use master
Alter server audit audit1 with (state=on)
go
use audit_test
alter database audit specification TestAuditSpec with (state=on)
go
	
--Verify Audit is on (1 = Enabled)
select is_state_enabled from sys.server_file_audits
select is_state_enabled from sys.database_audit_specifications
go

--fire event
use audit_test
execute as user='test'
select * from schema1.t1
revert
go

--read audit result
select statement,* from fn_get_audit_file ('c:\temp\*',null,null) 
go

--cleanup
use master
Alter server audit audit1 with (state=off)
drop server audit audit1 
use audit_test
Alter database AUDIT SPECIFICATION TestAuditSpec with (state=off)
drop database AUDIT SPECIFICATION TestAuditSpec
go

drop table schema1.t1
go
drop schema schema1
go


--2. Audit Login/logout/failed login
--create audit
use master
CREATE SERVER AUDIT audit1 TO FILE(FILEPATH='c:\temp\');
go

--create audit specification
CREATE SERVER AUDIT SPECIFICATION TestAuditSpec FOR SERVER AUDIT audit1
add(SUCCESSFUL_LOGIN_GROUP),
add(LOGOUT_GROUP),
add(FAILED_LOGIN_GROUP)
go

--turn on audit
use master
Alter server audit audit1 with (state=on)

-- simulate an user login 


--read audit result
select statement,* from fn_get_audit_file ('c:\temp\*',null,null) 
go

--cleanup
use master
Alter server audit audit1 with (state=off)
drop server audit audit1 
Alter SERVER AUDIT SPECIFICATION TestAuditSpec with (state=off)
drop SERVER AUDIT SPECIFICATION TestAuditSpec
go
